// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice
#include "marine_sensor_msgs/msg/detail/radar_sector__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `time_increment`
// Member `scan_time`
#include "builtin_interfaces/msg/detail/duration__functions.h"
// Member `intensities`
#include "marine_sensor_msgs/msg/detail/radar_echo__functions.h"

bool
marine_sensor_msgs__msg__RadarSector__init(marine_sensor_msgs__msg__RadarSector * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marine_sensor_msgs__msg__RadarSector__fini(msg);
    return false;
  }
  // angle_start
  // angle_increment
  // time_increment
  if (!builtin_interfaces__msg__Duration__init(&msg->time_increment)) {
    marine_sensor_msgs__msg__RadarSector__fini(msg);
    return false;
  }
  // scan_time
  if (!builtin_interfaces__msg__Duration__init(&msg->scan_time)) {
    marine_sensor_msgs__msg__RadarSector__fini(msg);
    return false;
  }
  // range_min
  // range_max
  // intensities
  if (!marine_sensor_msgs__msg__RadarEcho__Sequence__init(&msg->intensities, 0)) {
    marine_sensor_msgs__msg__RadarSector__fini(msg);
    return false;
  }
  return true;
}

void
marine_sensor_msgs__msg__RadarSector__fini(marine_sensor_msgs__msg__RadarSector * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // angle_start
  // angle_increment
  // time_increment
  builtin_interfaces__msg__Duration__fini(&msg->time_increment);
  // scan_time
  builtin_interfaces__msg__Duration__fini(&msg->scan_time);
  // range_min
  // range_max
  // intensities
  marine_sensor_msgs__msg__RadarEcho__Sequence__fini(&msg->intensities);
}

bool
marine_sensor_msgs__msg__RadarSector__are_equal(const marine_sensor_msgs__msg__RadarSector * lhs, const marine_sensor_msgs__msg__RadarSector * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // angle_start
  if (lhs->angle_start != rhs->angle_start) {
    return false;
  }
  // angle_increment
  if (lhs->angle_increment != rhs->angle_increment) {
    return false;
  }
  // time_increment
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->time_increment), &(rhs->time_increment)))
  {
    return false;
  }
  // scan_time
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->scan_time), &(rhs->scan_time)))
  {
    return false;
  }
  // range_min
  if (lhs->range_min != rhs->range_min) {
    return false;
  }
  // range_max
  if (lhs->range_max != rhs->range_max) {
    return false;
  }
  // intensities
  if (!marine_sensor_msgs__msg__RadarEcho__Sequence__are_equal(
      &(lhs->intensities), &(rhs->intensities)))
  {
    return false;
  }
  return true;
}

bool
marine_sensor_msgs__msg__RadarSector__copy(
  const marine_sensor_msgs__msg__RadarSector * input,
  marine_sensor_msgs__msg__RadarSector * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // angle_start
  output->angle_start = input->angle_start;
  // angle_increment
  output->angle_increment = input->angle_increment;
  // time_increment
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->time_increment), &(output->time_increment)))
  {
    return false;
  }
  // scan_time
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->scan_time), &(output->scan_time)))
  {
    return false;
  }
  // range_min
  output->range_min = input->range_min;
  // range_max
  output->range_max = input->range_max;
  // intensities
  if (!marine_sensor_msgs__msg__RadarEcho__Sequence__copy(
      &(input->intensities), &(output->intensities)))
  {
    return false;
  }
  return true;
}

marine_sensor_msgs__msg__RadarSector *
marine_sensor_msgs__msg__RadarSector__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marine_sensor_msgs__msg__RadarSector * msg = (marine_sensor_msgs__msg__RadarSector *)allocator.allocate(sizeof(marine_sensor_msgs__msg__RadarSector), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marine_sensor_msgs__msg__RadarSector));
  bool success = marine_sensor_msgs__msg__RadarSector__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marine_sensor_msgs__msg__RadarSector__destroy(marine_sensor_msgs__msg__RadarSector * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marine_sensor_msgs__msg__RadarSector__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marine_sensor_msgs__msg__RadarSector__Sequence__init(marine_sensor_msgs__msg__RadarSector__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marine_sensor_msgs__msg__RadarSector * data = NULL;

  if (size) {
    data = (marine_sensor_msgs__msg__RadarSector *)allocator.zero_allocate(size, sizeof(marine_sensor_msgs__msg__RadarSector), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marine_sensor_msgs__msg__RadarSector__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marine_sensor_msgs__msg__RadarSector__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marine_sensor_msgs__msg__RadarSector__Sequence__fini(marine_sensor_msgs__msg__RadarSector__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marine_sensor_msgs__msg__RadarSector__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marine_sensor_msgs__msg__RadarSector__Sequence *
marine_sensor_msgs__msg__RadarSector__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marine_sensor_msgs__msg__RadarSector__Sequence * array = (marine_sensor_msgs__msg__RadarSector__Sequence *)allocator.allocate(sizeof(marine_sensor_msgs__msg__RadarSector__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marine_sensor_msgs__msg__RadarSector__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marine_sensor_msgs__msg__RadarSector__Sequence__destroy(marine_sensor_msgs__msg__RadarSector__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marine_sensor_msgs__msg__RadarSector__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marine_sensor_msgs__msg__RadarSector__Sequence__are_equal(const marine_sensor_msgs__msg__RadarSector__Sequence * lhs, const marine_sensor_msgs__msg__RadarSector__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marine_sensor_msgs__msg__RadarSector__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marine_sensor_msgs__msg__RadarSector__Sequence__copy(
  const marine_sensor_msgs__msg__RadarSector__Sequence * input,
  marine_sensor_msgs__msg__RadarSector__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marine_sensor_msgs__msg__RadarSector);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    marine_sensor_msgs__msg__RadarSector * data =
      (marine_sensor_msgs__msg__RadarSector *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marine_sensor_msgs__msg__RadarSector__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          marine_sensor_msgs__msg__RadarSector__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marine_sensor_msgs__msg__RadarSector__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
