// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice

#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__FUNCTIONS_H_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "marine_sensor_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marine_sensor_msgs/msg/detail/radar_sector__struct.h"

/// Initialize msg/RadarSector message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marine_sensor_msgs__msg__RadarSector
 * )) before or use
 * marine_sensor_msgs__msg__RadarSector__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__init(marine_sensor_msgs__msg__RadarSector * msg);

/// Finalize msg/RadarSector message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__RadarSector__fini(marine_sensor_msgs__msg__RadarSector * msg);

/// Create msg/RadarSector message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marine_sensor_msgs__msg__RadarSector__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
marine_sensor_msgs__msg__RadarSector *
marine_sensor_msgs__msg__RadarSector__create();

/// Destroy msg/RadarSector message.
/**
 * It calls
 * marine_sensor_msgs__msg__RadarSector__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__RadarSector__destroy(marine_sensor_msgs__msg__RadarSector * msg);

/// Check for msg/RadarSector message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__are_equal(const marine_sensor_msgs__msg__RadarSector * lhs, const marine_sensor_msgs__msg__RadarSector * rhs);

/// Copy a msg/RadarSector message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__copy(
  const marine_sensor_msgs__msg__RadarSector * input,
  marine_sensor_msgs__msg__RadarSector * output);

/// Initialize array of msg/RadarSector messages.
/**
 * It allocates the memory for the number of elements and calls
 * marine_sensor_msgs__msg__RadarSector__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__Sequence__init(marine_sensor_msgs__msg__RadarSector__Sequence * array, size_t size);

/// Finalize array of msg/RadarSector messages.
/**
 * It calls
 * marine_sensor_msgs__msg__RadarSector__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__RadarSector__Sequence__fini(marine_sensor_msgs__msg__RadarSector__Sequence * array);

/// Create array of msg/RadarSector messages.
/**
 * It allocates the memory for the array and calls
 * marine_sensor_msgs__msg__RadarSector__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
marine_sensor_msgs__msg__RadarSector__Sequence *
marine_sensor_msgs__msg__RadarSector__Sequence__create(size_t size);

/// Destroy array of msg/RadarSector messages.
/**
 * It calls
 * marine_sensor_msgs__msg__RadarSector__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__RadarSector__Sequence__destroy(marine_sensor_msgs__msg__RadarSector__Sequence * array);

/// Check for msg/RadarSector message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__Sequence__are_equal(const marine_sensor_msgs__msg__RadarSector__Sequence * lhs, const marine_sensor_msgs__msg__RadarSector__Sequence * rhs);

/// Copy an array of msg/RadarSector messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__RadarSector__Sequence__copy(
  const marine_sensor_msgs__msg__RadarSector__Sequence * input,
  marine_sensor_msgs__msg__RadarSector__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__FUNCTIONS_H_
