// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marine_sensor_msgs:msg/TurbidityNTU.idl
// generated code does not contain a copyright notice

#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__TRAITS_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marine_sensor_msgs/msg/detail/turbidity_ntu__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace marine_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TurbidityNTU & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: ntu
  {
    out << "ntu: ";
    rosidl_generator_traits::value_to_yaml(msg.ntu, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TurbidityNTU & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: ntu
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ntu: ";
    rosidl_generator_traits::value_to_yaml(msg.ntu, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TurbidityNTU & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marine_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marine_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marine_sensor_msgs::msg::TurbidityNTU & msg,
  std::ostream & out, size_t indentation = 0)
{
  marine_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marine_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marine_sensor_msgs::msg::TurbidityNTU & msg)
{
  return marine_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marine_sensor_msgs::msg::TurbidityNTU>()
{
  return "marine_sensor_msgs::msg::TurbidityNTU";
}

template<>
inline const char * name<marine_sensor_msgs::msg::TurbidityNTU>()
{
  return "marine_sensor_msgs/msg/TurbidityNTU";
}

template<>
struct has_fixed_size<marine_sensor_msgs::msg::TurbidityNTU>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<marine_sensor_msgs::msg::TurbidityNTU>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<marine_sensor_msgs::msg::TurbidityNTU>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__TRAITS_HPP_
